<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8" />
    <title>Category API</title>

    <link rel="stylesheet" href="/css/bootstrap.min.css">

</head>

<body class="bg-light">
    <nav class="navbar navbar-expand-lg navbar-light bg-white border-bottom">
        <a class="navbar-brand" href="#">Point of Sale</a>
    </nav>
    <div class="container-fluid">
        <div class="row" style="min-height: 93.8vh">
            <div class="col-md-2 bg-white shadow">
                <div class="list-group mt-3">
                    <a href="/category/index" class="list-group-item list-group-item-action ">Category</a>
                    <a href="/variant/index" class="list-group-item list-group-item-action ">Variant</a>
                    <a href="/product/index" class="list-group-item list-group-item-action ">Product</a>
                    <a href="/orderheader/index" class="list-group-item list-group-item-action ">Order header</a>
                    <a href="/orderdetail/index" class="list-group-item list-group-item-action active">Order detail</a>
                </div>
            </div>
            <div class="col-md-10">
                <div class="card mt-3">
                    <div class="card-body shadow">
                        <h2>Order Detail</h2>
                        </hr>
                        <h4>Order List Detail</h4>
                        <button class="btn btn-primary" onclick="NewOrder()">New Order</button>
                        <div id="mainContent"></div>
                        <div class="mt-3" id="dataList"></div>
                    </div>
                </div>
            </div>
        </div>
    </div>

    <!-- Modal -->
    <div class="modal fade" id="myModal" tabindex="-1" aria-labelledby="exampleModalLabel" aria-hidden="true">
        <div class="modal-dialog">
            <div class="modal-content">
                <div class="modal-header">
                    <h5 class="modal-title" id="exampleModalLabel">Modal title</h5>
                </div>
                <div class="modal-body"></div>
            </div>
        </div>
    </div>

    <script src="/js/jquery-3.5.1.min.js"></script>
    <script src="/js/bootstrap-bundle.min.js"></script>
    <script>
        function DataList() {
            $.ajax({
                url: '/api/orderdetailbyorder/' + $('#orderHeaderId').val(),
                type: 'get',
                contentType: 'application/json',
                success: function(data) {
                    console.log("dataList: ", data)
                    let table = "<table class='table table-bordered'>"
                    table += "<tr>"
                    table += "<td>Reference</td>"
                    table += "<td>Product</td>"
                    table += "<td>Price</td>"
                    table += "<td>Qty</td>"
                    table += "<td>Total</td>"
                    table += "<td>Action</td>"
                    table += "</tr>"
                    let totalAmount = 0;
                    for (i = 0; i < data.length; i++) {
                        var ref = data[i].orderHeader.reference;
                        var total = data[i].price * data[i].quantity;
                        table += "<tr>"
                        table += "<td>" + data[i].orderHeader.reference + "</td>"
                        table += "<td>" + data[i].product.productName + "</td>"
                        table += "<td>" + data[i].price + "</td>"
                        table += "<td>" + data[i].quantity + "</td>"
                        table += "<td>" + total + "</td>"
                        table += "<td><button value='" + data[i].id + "' class='btn btn-sm btn-danger' onclick='MinOrder(this.value)'>-</button></td>"
                        table += "</tr>"
                        totalAmount += total;
                    }
                    table += "<tr>"
                    table += "<td colspan='4'>Total Amount</td>"
                    table += "<td><input type='text' id='totalAmount' class='form-control' value='" + totalAmount + "' readonly></td>"
                    table += "</tr>"
                    table += "</table>"
                    table += "<input type='text' class='form-control' id='ref' value='" + ref + "'>"
                    table += "<p><button class='btn btn-sm btn-primary' onclick='DoneProcess()'>Done</button></p>"
                    $('#dataList').html(table)
                }
            })
        }

        function NewOrder() {
            var reference = '{"reference":"","amount":"0"}';
            $.ajax({
                url: '/api/orderheader',
                type: 'post',
                contentType: 'application/json',
                data: reference,
                success: function(data) {
                    $.ajax({
                        url: '/api/orderheadergetmaxid',
                        type: 'get',
                        contentType: 'application/json',
                        success: function(data) {
                            console.log("maxID: ", data)
                            $('#orderHeaderId').val(data);
                            DataList();
                        }
                    })
                }
            })
            var table = '<table>';
            table += '<tr><td colspan="7">Header id : <input type="text" id="orderHeaderId" class="form-control" readonly></td></tr>';
            table += '<tr>'
            table += '<td>Product</td>';
            table += '<td><select class="form-control" onchange="GetPrice(this.value)" id="productId"></select></td>';
            table += '<td>Price</td>';
            table += '<td><input class="form-control" type="text" size="10" maxlength="10" class="form-control" id="productPrice" readonly></td>';
            table += '<td>Quantity</td>';
            table += '<td><input class="form-control" type="number" id="quantity" required value="1" style="width:80px;"></td>';
            table += '<td><button onclick="AddOrder()" class="btn btn-success">+</button></td>';
            table += '</tr>';
            table += '</table>';
            $('#mainContent').html(table);

            var p = '<option>--Select product--</option>';
            $.ajax({
                url: '/api/product',
                type: 'get',
                contentType: 'application/json',
                success: function(data) {
                    console.log("product: ", data)
                    for (i = 0; i < data.length; i++) {
                        p += '<option value="' + data[i].id + '">' + data[i].productName + '</option>';
                    }
                    $('#productId').html(p);
                }
            })
        }

        function GetPrice(id) {
            $.ajax({
                url: '/api/product/' + id,
                type: 'get',
                contentType: 'application/json',
                success: function(data) {
                    console.log(data)
                    $('#productPrice').val(data.productPrice);
                }
            })
        }

        function MinOrder(request) {
            console.log(request)
            $.ajax({
                url: '/api/orderdetail/' + request,
                type: 'delete',
                contentType: 'application/json',
                success: function(data) {
                    DataList();
                }
            })
        }

        function AddOrder() {
            var detailData = '{';
            detailData += '"orderHeaderId":"' + $('#orderHeaderId').val() + '",';
            detailData += '"productId":"' + $('#productId').val() + '",';
            detailData += '"price":"' + $('#productPrice').val() + '",';
            detailData += '"quantity":"' + $('#quantity').val() + '"';
            detailData += '}';
            $.ajax({
                url: '/api/orderdetail/',
                type: 'post',
                contentType: 'application/json',
                data: detailData,
                success: function(data) {
                    DataList();
                }
            })

        }

        function DoneProcess() {
            var dataHeader = '{ "reference":"' + $('#ref').val() + '","amount":"' + $('#totalAmount').val() + '" }'
            $.ajax({
                url: '/api/orderheader/' + $('#orderHeaderId').val(),
                type: 'put',
                contentType: 'application/json',
                data: dataHeader,
                success: function(data) {
                    console.log("orderHeader: ", data)

                    $.ajax({
                        url: '/api/orderheader/' + $('#orderHeaderId').val(),
                        type: 'get',
                        contentType: 'application/json',
                        success: function(data) {
                            console.log(data);
                            let table = '<table class="table table-bordered">';
                            table += "<tr>"
                            table += '<th>Reference #</th>'
                            table += '<th>Amount</th>'
                            table += "</tr>"
                            table += "<tr>"
                            table += "<td>" + data.reference + "</td>"
                            table += "<td>" + data.amount + "</td>"
                            table += "</tr>"
                            table += "</table>";
                            table += '<p align="center"><button class="btn btn-sm btn-primary" onclick="javascript:location.replace(\'/orderdetail/index\')">Order Lagi</button></p>'
                            $('.modal-title').html("Order Amount");
                            $('.modal-body').html(table);
                            $('#myModal').modal('show')
                        }
                    })

                }
            })
        }
    </script>
</body>

</html>